;*********************************************
;* water level sensor sender BY FRESH NELLY! *
;*********************************************
LIST P=16C57
; PWM OUTPUT =  ,OUTPUT LOGIC 1 IS 75% DUTY,LOGIC 0 IS 50% DUTY
;1 START BIT 8 DATA BITS. INCOMPLETE READ BY DISPLAY PIC CAN BE
;SENSED IF COUNT ISN'T 9 PULSES (DISPLAY PIC SLEEPS AS WELL UNTIL TOCK ACTIVE BY USER)
;REEDS INPUT PORTB,0-7,TEST LEDS OUT PORTC,0-7
;pwm output(A,0) turns on pull down Q on power wire, sensed by level display pic
;WDT BIT ON,CP OFF
;FRQ=3.579545 MHZ ~ 1.1174605 uS/INSTR
INDF     EQU     0X00
RTCC     EQU     0X01
PCL      EQU     0X02
STATUS   EQU     0X03
FSR      EQU     0X04
PORTA    EQU     0X05
PORTB    EQU     0X06
PORTC    EQU     0X07
ROTBUF   EQU     0X08
TEMP     EQU     0X09
W        EQU     0X0A
TIMER0   EQU     0X0B
TIMER1   EQU     0X0C
SSTATUS  EQU     0X0D
RDBUF1   EQU     0X0E
RDBUF2   EQU     0X0F




;
;INIT
	ORG     07FF	;POWER UP
	NOP
	ORG     0X00
	BSF	SSTATUS,0
	GOTO	START	;*****TEMP TEMP!
	;BTFSC	STATUS,3 ;SLEEP FLAGS, SET IF POWER ON RESET
	;GOTO	START
	;BTFSC	STATUS,4	;
	;GOTO	START
	GOTO	WAKE
	
START   	;enable wdt off rc osc and /128 to give 2.3 sec sleep
	MOVLW 	B'00101111' 
	;OPTION

	MOVLW	0XFF
	TRIS	PORTB
	MOVWF	PORTB
	MOVLW	0X0E
	TRIS	PORTA
	MOVLW	0X00
	TRIS	PORTC	;**ALL OUTPUT FOR TESTING
	BCF	PORTA,0	;CLEAR VOLTAGE TO 'PULL DOWN TRANSISTOR' Q1
	CLRF	ROTBUF
	CLRF	RDBUF1	;INVERTED COPY OFF OF PORTB REED SWITCH INPUT
	CLRF	RDBUF2	;LAST READING BUFF--ASSUMES EMPTY TANK,DECIMAL BUFFER(0 TO 7)
WAKE	MOVF	PORTB,W
	MOVWF	RDBUF1	;BUF FOR ROTATE COUNTING
	COMF	RDBUF1	;1'S INDICATE ACTIVE REEDS
	BTFSC	STATUS,2	;SKIP IF ANY REED ACTIVE
	GOTO	SLP	;NOT READY YET
	MOVLW	.8
	MOVWF	TIMER1	;FOR COUNTDOWN
	BCF	STATUS,0	;CLEAR CARRY
WKLP	DECF	TIMER1	;MAX .7,MIN 0
	RLF	RDBUF1
	BTFSS	STATUS,0	;CARRY SET?
	GOTO	WKLP
	MOVF	TIMER1,W
	SUBWF	RDBUF2,W
	BTFSS	STATUS,0	;CARRY=1 IF RESULT IS POS(LEVEL GOING DOWN) OR EQUAL (NO CHANGE)
	GOTO	UPWARD
	GOTO	DOWNWD
UPWARD	MOVF	TIMER1,W
	MOVWF	RDBUF2	;SET TO NEW LEVEL
	CALL	SEND
	GOTO	SLP
DOWNWD	BTFSS	PORTB,0	;BOTTOMED OUT REED SWITCH (LOW)
	GOTO	RESET
	MOVWF	TIMER0	;TEMP USE TO SEE IF GONE DOWN 2
	MOVLW	.2
	SUBWF	TIMER0	;IF RESULT IS NEG THEN NOT DOWN 2 REEDS YET
	BTFSS	STATUS,0	; SKIP IF DOWN 2(>1)
	GOTO	SLP	;DON'T SEND
	DECFSZ	RDBUF2
	DECF	RDBUF2
	BSF	SSTATUS,0	;GOING DOWN FLAG
	CALL	SEND
	GOTO	SLP

RESET	BTFSS	SSTATUS,0
	GOTO	SLP	;DON'T SEND
	BCF	SSTATUS,0
	MOVLW	0X00
	MOVWF	RDBUF2
	CALL	SEND
	GOTO	SLP

TABLE1	
	ADDWF	PCL
	RETLW	B'00000001'	;0
	RETLW	B'00000010'
	RETLW	B'00000100'
	RETLW	B'00001000'
	RETLW	B'00010000'
	RETLW	B'00100000'
	RETLW	B'01000000'
	RETLW	B'10000000'	;7
	
	

SLP	;SLEEP
	GOTO	WAKE
SEND
	;SEND DATA PWM
	MOVF	RDBUF2,W
	CALL	TABLE1
	MOVWF	ROTBUF
	MOVF	ROTBUF,W	; FOR TESTING
	MOVWF	PORTC		; LEDS,REMOVE
	MOVLW	0X08
	MOVWF	TIMER1	
	RRF	ROTBUF

	CALL	BIT1	;STARTBIT
LP	RLF	ROTBUF
	BTFSS	ROTBUF,7
	CALL	BIT0
	BTFSC	ROTBUF,7
	CALL	BIT1
	DECFSZ	TIMER1
	GOTO	LP
	RETLW	0X00
	
BIT1	NOP
LP0	BSF	PORTA,0	;1	/4
	DECFSZ	TIMER0
	GOTO 	LP0
	MOVLW	0X7F
	MOVWF	TIMER0
LP1	NOP
	DECFSZ	TIMER0	
	GOTO	LP1
	BCF	PORTA,0
	MOVLW	0X7E
	MOVWF	TIMER0
LP2	NOP
	DECFSZ	TIMER0
	GOTO	LP2
	RETLW	0X00
	
BIT0	BSF	PORTA,0	;50% DUTY CYCLE
	DECFSZ	TIMER0
	GOTO	BIT0
	BCF	PORTA,0
LP3	NOP
	DECFSZ	TIMER0
	GOTO	LP3
	RETLW	0X00

	END
;DISPLAY PIC could be setup as a power on /hold/shutdown if inactive after x receive cycles
;using a Q before the 5 volt regulator.

